---
title: AudioWorkletGlobalScope.registerProcessor
slug: Web/API/AudioWorkletGlobalScope/registerProcessor
tags:
  - API
  - Audio
  - AudioWorkletGlobalScope
  - AudioWorkletProcessor
  - Method
  - Reference
  - Web Audio API
---
<p>{{ APIRef("Web Audio API") }}</p>

<p>The <strong><code>registerProcessor</code></strong> method of the {{domxref("AudioWorkletGlobalScope")}} interface registers a class constructor derived from {{domxref("AudioWorkletProcessor")}} interface under a specified <em>name</em>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>AudioWorkletGlobalScope</em>.registerProcessor(<em>name</em>, <em>processorCtor</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>name</code></dt>
 <dd>A string representing the name under which the processor will be registered.</dd>
 <dt><code>processorCtor</code></dt>
 <dd>The constructor of a class derived from {{domxref("AudioWorkletProcessor")}}.</dd>
</dl>

<div class="notecard note">
<p><strong>Note</strong>: A key-value pair <code>{ <em>name:</em> constructor }</code> is saved internally in the {{domxref("AudioWorkletGlobalScope")}} once  the processor is registered. The <em>name</em> is to be referred to when creating an {{domxref("AudioWorkletNode")}} based on the registered processor. A new processor by the given name is internally created and associated with the new node.</p>
</div>

<h3 id="Return_value">Return value</h3>

<p>{{jsxref("undefined")}}</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>NotSupportedError</code></dt>
 <dd>
 <ul>
  <li>The <em>name</em> is an empty string, or</li>
  <li>a constructor under the given <em>name</em> is already registered. Registering the same name twice is not allowed.</li>
 </ul>
 </dd>
 <dt><code>TypeError</code></dt>
 <dd>
 <ul>
  <li>The <em>processorCtor</em> is not a callable constructor, or</li>
  <li>the {{domxref("AudioWorkletProcessor.parameterDescriptors", "parameterDescriptors")}} property of the constructor exists and doesn't return an array of {{domxref("AudioParamDescriptor")}}-based objects.</li>
 </ul>
 </dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>In this example we create a custom <code>AudioWorkletNode</code> that outputs silence.</p>

<p>First, we need to define a custom {{domxref("AudioWorkletProcessor")}} and register it. Note that this should be done in a separate file.</p>

<pre class="brush: js">// test-processor.js
class TestProcessor extends AudioWorkletProcessor {
  process (inputs, outputs, parameters) {
    return true
  }
}

registerProcessor('test-processor', TestProcessor)
</pre>

<p>Next, in our main script file we'll load the processor, create an instance of <code>AudioWorkletNode</code> — passing it the processor name that we used when calling <code>registerProcessor</code> — and connect it to an audio graph.</p>

<pre class="brush: js">const audioContext = new AudioContext()
await audioContext.audioWorklet.addModule('test-processor.js')
const node = new AudioWorkletNode(audioContext, 'test-processor')
node.connect(audioContext.destination)
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#dom-audioworkletglobalscope-registerprocessor', 'registerProcessor()')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.AudioWorkletGlobalScope.registerProcessor")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
</ul>
